/* Dragon Memory
   Santiago Radeff 2010 - Spain
   http://www.dragontech.net/
*/
#include<stdio.h>
#include<stdarg.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
#ifdef ANDROID
#include<SDL.h>
#include<SDL_image.h>
#include<SDL_mixer.h>
#include <GLES/gl.h>
#include <GLES/glext.h>
#else
#include<SDL/SDL.h>
#include<SDL/SDL_image.h>
#include<SDL/SDL_mixer.h>
#include <GL/gl.h>
#include <GL/glext.h>
#include <sys/stat.h>
#endif

#include"define.h"
#include"timing.h"
#include"init.h"
#include"gfx.h"
#include"text.h"

#include"fx.h"
#include"file.h"
#include"music.h"
#include"levels.h"
#include"input.h"
#include"game.h"
#include"intro.h"
#include"menu.h"
#include"wingame.h"

int main (int argc, char * argv[])
{
    initSDL();
    initGL();
    showIntro();
    int option = 0;
    while(option != EXITGAME)
    {
	option = doMenu();
	while(option == PLAYGAME)
	{
	    option = doGame();
	    flushEvents();
	    if(option == LEVELCOMPLETE)
	    {
		showScoreInfo();
		levelNumber++;
		if(levelNumber > MAXLEVELS)
		{
		    winGame();
		    option = ENDGAME;
		}
		else
		    option = PLAYGAME;
	    } 
	}
    }
    return(0);
}
